<script setup lang="ts">
import { computed, defineProps, onMounted, ref } from 'vue'
import { useStore } from 'vuex'
import { ratioColor, statusColor, timeAgo } from '@/components/gitlab/helpers'

import type { Project } from '@/api/gitlabHelperApi/projectsApi'
import type { Group } from '@/api/gitlabHelperApi/groupsApi'

const props = defineProps<{
  projects: Project[]
  groups: Group[]
}>()

const store = useStore()
const user = ref({ username: '', rol: '' })

onMounted(() => {
  user.value = store.getters.user
  console.debug('ProjectsCardComponent.projects: ', props.projects)
  console.debug('GroupsCardComponent.groups: ', props.groups)
})

interface Project {
  id: string
  name: string
  health: {
    ratio: number
    status: string
    last_success: Date
    last_failure: Date
  }
  web_url: string
  namespace: {
    id: string
  }
}

const headers = computed(() => [
  { title: 'Icon', value: 'icon', class: 'min-width-status', sortable: true },
  { title: 'Status', value: 'status', class: 'min-width-status', sortable: true },
  { title: 'Health', value: 'healthRatio', class: 'min-width-status', sortable: true },
  { title: 'Project Name', value: 'name', class: 'min-width-status' },
  { title: 'Last Success', value: 'lastSuccess', class: 'min-width-status' },
  { title: 'Last Failure', value: 'lastFailure', class: 'min-width-status' },
  { title: 'Actions', value: 'actions', sortable: false },
])

const items = computed(() => props.projects.map(project => ({
  icon: project.icon,
  name: project.name,
  healthRatio: project.health.ratio,
  status: project.health.status,
  lastSuccess: project.health.last_success,
  lastFailure: project.health.last_failure,
  web_url: project.web_url,
  workspaceLink: { name: 'workspace', params: { id: project.namespace.id, projectId: project.id } },
})))

const resolveStatusVariant = (status: number) => {
  if (status === 1)
    return { color: 'primary', text: 'Current' }
  else if (status === 2)
    return { color: 'success', text: 'Professional' }
  else if (status === 3)
    return { color: 'error', text: 'Rejected' }
  else if (status === 4)
    return { color: 'warning', text: 'Resigned' }
  else
    return { color: 'info', text: 'Applied' }
}

/*
    show-select
    show-expand
 */
</script>

<template>
  <VDataTableServer
    density="compact"
    class="text-no-wrap"
    :headers="headers"
    :items="items"
    :sort-by="[{ key: 'name', order: 'asc' }]"
    :items-per-page="25"
    item-value="name"
    return-object
  >
    <!-- full name -->
    <template #item.fullName="{ item }">
      <div class="d-flex align-center">
        <VAvatar>
          <VImg
            v-if="item.avatar_url"
            :src="item.avatar_url"
          />
        </VAvatar>
        <div class="d-flex flex-column ms-3">
          <small>{{ item }}</small>
        </div>
      </div>
    </template>

    <!-- Nombre del proyecto -->
    <template #item.name="{ item }">
      <span class="font-weight-bold">{{ item.name }}</span>
    </template>

    <!-- Health Ratio con Circular Progress -->
    <template #item.healthRatio="{ item }">
      <VProgressCircular
        :model-value="item.healthRatio * 10"
        :size="25"
        :color="ratioColor(item.healthRatio)"
        class="me-2"
      >
        <span
          class="text-high-emphasis"
          style="font-size: small;"
        >
          {{ item.healthRatio }}
        </span>
      </VProgressCircular>
    </template>

    <!-- Estado de la última ejecución -->
    <template #item.status="{ item }">
      <VChip
        label
        :color="statusColor(item.status)"
      >
        {{ item.status }}
      </VChip>
    </template>

    <!-- Último éxito -->
    <template #item.lastSuccess="{ item }">
      <span>{{ timeAgo(item.lastSuccess) }}</span>
    </template>

    <!-- Último fallo -->
    <template #item.lastFailure="{ item }">
      <span>{{ timeAgo(item.lastFailure) }}</span>
    </template>

    <!-- Acciones -->
    <template #item.actions="{ item }">
      <VBtn
        :href="item.web_url"
        variant="text"
        size="small"
      >
        <VIcon
          color="primary"
          icon="tabler-external-link"
          size="16"
        />
      </VBtn>
      <VBtn :to="item.workspaceLink">
        Workspace
      </VBtn>
    </template>
  </VDataTableServer>
</template>

<style scoped>
.link-button {
  color: black; /* Cambia el color del texto a negro */
}

.link-button:hover {
  color: grey; /* Cambia el color del texto al pasar el mouse */
}
</style>
